<template>
  <v-container class="fill-height">
    <v-row row wrap align="center" justify-center pt-3>
      <v-col sm="12">
        <h1 class="display-2 text-xs-center primary--text mb-4">
          Clave Fiscal
        </h1>
      </v-col>
      <v-col v-if="certificate.estado_origen !== 'Certificado'" sm="12">
        <v-card class="profile">
          <v-card-text>
            <v-row row wrap align="center">
              <v-col
                v-show="isNewCert"
                sm="12"
                md="8"
                text-xs-center
                text-sm-left
                fill-height
              >
                <h4>
                  Para continuar con el trámite, es necesario que verifiques tu
                  información
                </h4>
              </v-col>
              <v-col
                v-show="
                  !isNewCert && certificate.estado_origen !== 'Certificado'
                "
                sm="12"
                md="8"
                text-xs-center
                text-sm-left
                fill-height
              >
                <h4>
                  Tu certificado está {{ certificate.estado_origen }}, puedes
                  mirar la información que compartiste en el siguiente
                  formulario.
                </h4>
              </v-col>
            </v-row>
          </v-card-text>
        </v-card>
        <br />
      </v-col>
      <v-col
        v-if="certificate.estado_origen !== 'Certificado'"
        sm="12"
        mb-3
        elevation-1
      >
        <v-form
          ref="form"
          v-model="valid"
          lazy-validation
          @submit.prevent="updateProfile"
        >
          <v-card>
            <v-card-text>
              <v-container fluid grid-list-md pa-0>
                <v-row wrap>
                  <v-col sm="12" mb-3>
                    <h3>Mi información</h3>
                  </v-col>
                  <v-col sm="12" md="6">
                    <v-text-field
                      v-model="certificate.type_person"
                      :loading="loading"
                      :rules="rules"
                      :disabled="disabled"
                      label="Tipo de Persona"
                      readonly
                      outlined
                    ></v-text-field>
                  </v-col>
                  <v-col sm="12" md="6">
                    <v-text-field
                      v-model="certificate.name_citizen"
                      :loading="loading"
                      :rules="rules"
                      :disabled="disabled"
                      label="Nombre"
                      readonly
                      outlined
                    ></v-text-field>
                  </v-col>
                  <v-col sm="12" md="6">
                    <v-text-field
                      v-model="certificate.last_name"
                      :loading="loading"
                      :rules="rules"
                      :disabled="disabled"
                      label="Apellido"
                      readonly
                      outlined
                    ></v-text-field>
                  </v-col>
                  <v-col sm="12" md="6">
                    <v-text-field
                      v-model="certificate.dni"
                      :loading="loading"
                      :rules="rules"
                      :disabled="disabled"
                      label="DNI"
                      outlined
                    ></v-text-field>
                  </v-col>
                  <v-col sm="12" md="6">
                    <v-text-field
                      v-model="certificate.email"
                      :loading="loading"
                      :rules="rules"
                      :disabled="disabled"
                      label="Email"
                      readonly
                      outlined
                    ></v-text-field>
                  </v-col>
                  <v-col sm="12" md="6">
                    <v-text-field
                      v-model="certificate.public_address"
                      :loading="loading"
                      :disabled="disabled"
                      :rules="rules"
                      label="ID pública"
                      readonly
                      outlined
                    ></v-text-field>
                  </v-col>
                  <v-col sm="12" md="6">
                    <v-text-field
                      v-model="certificate.address"
                      :loading="loading"
                      :rules="rules"
                      :disabled="disabled"
                      :readonly="readOnlyMode"
                      label="Domicilio"
                      outlined
                    ></v-text-field>
                  </v-col>
                  <v-col sm="12" md="6">
                    <v-text-field
                      v-model="certificate.locality"
                      :loading="loading"
                      :rules="rules"
                      :disabled="disabled"
                      label="Localidad"
                      outlined
                    ></v-text-field>
                  </v-col>
                  <v-col sm="12" md="6">
                    <client-only>
                      <vue-tel-input
                        v-model="certificate.phone"
                        name="Phone"
                        placeholder="Teléfono"
                        required
                        :valid-characters-only="true"
                        mode="international"
                        @validate="registerPhoneIsValid"
                      ></vue-tel-input>
                    </client-only>
                  </v-col>
                </v-row>
              </v-container>
            </v-card-text>
            <v-divider></v-divider>
            <v-card-actions class="px-3">
              <v-row row wrap>
                <v-col sm="12" class="text-xs-right">
                  <v-btn
                    :loading="loading"
                    :disabled="loading || !valid || disabled"
                    color="primary"
                    type="submit"
                  >
                    {{ readOnlyMode ? 'Verificar información' : 'Solicitar' }}
                  </v-btn>
                </v-col>
              </v-row>
            </v-card-actions>
          </v-card>
        </v-form>
      </v-col>
      <v-col
        v-if="certificate.estado_origen === 'Certificado'"
        sm="12"
        mb-3
        elevation-1
        class="relative"
      >
        <a :href="certificate.link" target="_blank">
          <v-btn fab top right absolute class="embedded-button">
            <v-icon>mdi-arrow-expand</v-icon>
          </v-btn>
        </a>
        <iframe
          :src="certificate.link"
          frameborder="0"
          class="certificate-template"
        ></iframe>
      </v-col>
      <v-snackbar
        v-model="snackbar.show"
        :top="true"
        :right="true"
        :timeout="snackbar.timeout"
        :color="snackbar.color"
        :multi-line="snackbar.mode === 'multi-line'"
        :vertical="snackbar.mode === 'vertical'"
      >
        {{ snackbar.text }}
        <v-btn
          icon
          class="float-right"
          justify="center"
          align="center"
          @click.native="snackbar.show = false"
        >
          <v-icon>mdi-close</v-icon>
        </v-btn>
      </v-snackbar>
    </v-row>
  </v-container>
</template>
<script lang="ts">
import Vue from 'vue'
import async from 'async'
import moment from 'moment'
import * as Papa from 'papaparse'

import { mapGetters } from 'vuex'
import { getUser, User } from '@/services/User'
import {
  BlockcertsCertificate,
  Certificate,
  CertificateToBlockcerts,
} from '@/services/Certificates'
import SendEmailVerificationMixin from '@/mixins/SendEmailVerificationMixin'

export default Vue.extend({
  mixins: [SendEmailVerificationMixin],
  middleware: ['completedata'],
  data() {
    return {
      loading: false,
      hasName: false,
      photoURL: null,
      readOnlyMode: false,
      firebaseCollection: 'certificates',
      reCAPTCHA: '',
      show: false,
      valid: false,
      certificate: {} as Certificate,
      blockcertsCertificate: {} as BlockcertsCertificate,
      photo_name: '',
      picture: null,
      redirect: '/citizen/certificates/',
      user: {} as User,
      disabled: false,
      modalSelectDate: false,
      rules: [(v: any) => !!v || 'El campo es requerido'],
      snackbar: {
        show: false,
        color: '',
        mode: '',
        timeout: 6000,
        text: '',
        right: '',
        top: '',
      },
      rulesEmail: [
        (v: any) => !!v || 'El campo es requerido',
        (v: any) =>
          !v ||
          /^[-\w.%+]{1,64}@(?:[A-Z0-9-]{1,63}\.){1,125}[A-Z]{2,63}$/i.test(v) ||
          'Ingresa un email válido',
      ],
      registerPhoneValidation: false,
    }
  },
  computed: {
    form(): Vue & { validate: () => boolean } {
      return this.$refs.form as Vue & { validate: () => boolean }
    },
    ...mapGetters({
      userStore: 'users/user',
    }),
    isNewCert(): boolean {
      return !this.certificate.estado_origen
    },
    isVerified(): boolean {
      const userStore = this.$store.state.user
      return (
        (userStore && userStore.email && userStore.emailVerified) ||
        (userStore && userStore.phoneNumber)
      )
    },
    isValidUser(): boolean {
      return this.hasName && this.isVerified
    },
  },
  watch: {
    modalSelectDate(val) {
      val &&
        setTimeout(
          () =>
            ((
              this.$refs.birthdayPicker as Vue & {
                activePicker: string
              }
            ).activePicker = 'YEAR')
        )
    },
  },
  mounted() {
    const self = this
    async.waterfall(
      [
        (callback: (error: Error | null, response?: any) => void) => {
          // Get already sent certificates
          self
            .getCertificate()
            .then((certs: any) => {
              if (!certs.empty) {
                certs.forEach((doc: any) => {
                  self.certificate = doc.data()
                  if (
                    self.certificate.is_certified &&
                    !self.certificate.is_revocated
                  ) {
                    self.disabled = true
                  }
                })
              }
              callback(null)
            })
            .catch((error: Error) => {
              callback(error)
            })
        },
        (callback: (error: Error | null, response?: any) => void) => {
          if (!self.certificate.name_citizen) {
            // No certificates were found, use user data to create new certificate
            getUser(self.$fire, self.userStore.uid)
              .then((res) => {
                if (res.exists) {
                  const userData = res.data()
                  self.user = {
                    ...userData,
                    name_citizen: userData.first_name,
                    id_user: userData.uid,
                    foto: userData.uid,
                    birthdate: userData.birthdate,
                    phone: userData.phone,
                  }
                }
                callback(null, self.user)
              })
              .catch((err) => {
                console.error(err)
                callback(err)
              })
          } else {
            callback(null, self.certificate)
          }
        },
        (
          user: any,
          callback: (error: Error | null, response?: any) => void
        ) => {
          if (user) {
            self.certificate.name_citizen = `${user.name_citizen} ${user.last_name}`
            self.certificate.email = user.email
            self.certificate.id_user = user.id_user
            self.certificate.public_address = user.public_address
            self.certificate.dni = user.dni
            if (user.firstName && user.lastName) {
              self.hasName = true
            }
          }
          callback(null)
        },
      ],
      (err) => {
        if (err) {
          console.error(err)
          self.snackbar.show = true
          self.snackbar.text = err.message
          self.snackbar.color = 'error'
        }
      }
    )
  },
  methods: {
    registerPhoneIsValid($event: any) {
      this.registerPhoneValidation = $event.isValid
    },
    getCertificate() {
      let matchProperty = 'idUser'
      let matchValue = this.userStore.uid
      if (this.$route.params.cert) {
        matchProperty = 'id_reference'
        matchValue = this.$route.params.cert
      }
      return this.$fire.firestore
        .collection(this.firebaseCollection)
        .where(matchProperty, '==', matchValue)
        .get()
    },
    updateProfile() {
      if (this.form.validate()) {
        // this.$wait.start('full')
        this.loading = true
        async.waterfall(
          [
            (callback: (err: any, res?: any) => void) => {
              this.certificate.identity = 'info@os.city'
              this.certificate.name = `${this.certificate.name_citizen} ${this.certificate.last_name}`
              this.certificate.pubkey = this.certificate.public_address
                ? `ecdsa-koblitz-pubkey:${this.certificate.public_address}`
                : 'ecdsa-koblitz-pubkey:0xCc386B6f1ca0cffAe3819cEb74622d8308f7258c'
              this.certificate.estado_origen = 'En espera'
              this.certificate.type = 'clave-fiscal'
              this.certificate.title = 'Clave Fiscal'
              this.certificate.created = moment().format()
              this.$fire.firestore
                .collection(this.firebaseCollection)
                .add(this.certificate)
                .then((docRef: any) => {
                  callback(null, docRef)
                })
                .catch((error: Error) => {
                  callback(error)
                })
            },
            (doc: any, callback: (err: any, res?: any) => void) => {
              this.certificate.id_reference = doc.id
              const document = this.$fire.firestore
                .collection(this.firebaseCollection)
                .doc(this.certificate.id_reference)
              document
                .set(
                  { id_reference: this.certificate.id_reference },
                  { merge: true }
                )
                .then(() => {
                  callback(null)
                })
                .catch((error: Error) => {
                  callback(error)
                })
            },
            (callback: (err: any, res?: any) => void) => {
              const fullData: BlockcertsCertificate[] = []
              // Remove ref and estado_origen from original certificate
              const finalCertficate = CertificateToBlockcerts(this.certificate)
              fullData.push(finalCertficate)
              // Upload file
              const i = Papa.unparse(fullData)
              const blob = new Blob(['\uFEFF', i], {
                type: 'data:text/csv;charset=utf-8',
              })
              const fileName = `dni_${this.userStore.uid}.csv`
              const fileRef = this.$fire.storage
                .ref()
                .child('certificates/' + fileName)
              fileRef
                .put(blob)
                .then(function () {
                  callback(null)
                })
                .catch(function (error: Error) {
                  callback(error)
                })
            },
          ],
          (err) => {
            this.snackbar.show = true
            if (err) {
              console.error(err)
              this.snackbar.text = err.message
              this.snackbar.color = 'error'
            } else {
              this.snackbar.text =
                'Gracias por verificar tus datos, se hará llegar la información para tu trámite.'
              this.snackbar.color = 'success'
              setTimeout(() => {
                this.$router.push({
                  path: this.redirect,
                })
              }, 1000)
            }
            this.loading = false
          }
        )
      }
    },
    uploadPhoto() {
      // url) {
      this.snackbar.show = true
      this.snackbar.text = 'Foto actualizada con éxito.'
      this.snackbar.color = 'success'
    },
  },
})
</script>

<style lang="scss" scoped>
.profile.v-card {
  .v-card__title {
    > div {
      margin-left: 12.5%;
    }
  }

  .v-btn.v-btn--absolute {
    left: 5%;
  }
}

.deactivate-border {
  border-right: 1px solid #efefef;
}

.code-verify {
  margin-top: 55px;
}
iframe.certificate-template {
  width: 100%;
  height: 90vh;
}
.relative {
  position: relative;
}
.embedded-button {
  top: 1em;
}
.vue-tel-input {
  height: 56px !important;
}
</style>
